////////////////////////////////////////////////////////////////////////////////
//
// Fichero:
//      CD3D9Trace.h
//
// Descripcin:
//      Declaracin de la clase CD3D9Trace
//
// Historial:
//      16/MAR/2003 Creacin
//
////////////////////////////////////////////////////////////////////////////////


#ifndef __CD3D9TRACE_H__
#define __CD3D9TRACE_H__


////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////
#include <d3d9.h>


////////////////////////////////////////////////////////////////////////////////
// Declaracin
////////////////////////////////////////////////////////////////////////////////

namespace D3D9Trace
{

    class CD3D9Trace : public IDirect3D9
    {

    //
    // Constructor
    //
     public:
        explicit CD3D9Trace::CD3D9Trace(IDirect3D9 * const pv_pInterface);

    //
    // Set/Get
    //
     private:
        inline void CD3D9Trace::SetInterface(IDirect3D9 * const pv_pInterface);
        inline IDirect3D9 * CD3D9Trace::GetInterface(void) const;
 
    //
    // IUnknow
    //
     private:
        HRESULT STDMETHODCALLTYPE CD3D9Trace::QueryInterface(REFIID riid, void** ppvObj);
        ULONG   STDMETHODCALLTYPE CD3D9Trace::AddRef(void);
        ULONG   STDMETHODCALLTYPE CD3D9Trace::Release(void);

    //
    // IDirect3D9
    //
     private:
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CheckDepthStencilMatch(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, D3DFORMAT RenderTargetFormat, D3DFORMAT DepthStencilFormat);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CheckDeviceFormat(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, DWORD Usage, D3DRESOURCETYPE RType, D3DFORMAT CheckFormat);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CheckDeviceFormatConversion(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SourceFormat, D3DFORMAT TargetFormat);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CheckDeviceMultiSampleType(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SurfaceFormat, BOOL Windowed, D3DMULTISAMPLE_TYPE MultiSampleType, DWORD* pQualityLevels);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CheckDeviceType(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT DisplayFormat, D3DFORMAT BackBufferFormat, BOOL Windowed);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::CreateDevice(UINT Adapter, D3DDEVTYPE DeviceType, HWND hFocusWindow, DWORD BehaviorFlags, D3DPRESENT_PARAMETERS *pPresentationParameters, IDirect3DDevice9** ppReturnedDeviceInterface);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::EnumAdapterModes(UINT Adapter, D3DFORMAT Format, UINT Mode, D3DDISPLAYMODE* pMode);
        UINT     STDMETHODCALLTYPE CD3D9Trace::GetAdapterCount(VOID);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::GetAdapterDisplayMode(UINT Adapter, D3DDISPLAYMODE *pMode);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::GetAdapterIdentifier(UINT Adapter, DWORD Flags, D3DADAPTER_IDENTIFIER9 *pIdentifier);
        UINT     STDMETHODCALLTYPE CD3D9Trace::GetAdapterModeCount(UINT Adapter, D3DFORMAT Format);
        HMONITOR STDMETHODCALLTYPE CD3D9Trace::GetAdapterMonitor(UINT Adapter);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::GetDeviceCaps(UINT Adapter, D3DDEVTYPE DeviceType, D3DCAPS9 *pCaps);
        HRESULT  STDMETHODCALLTYPE CD3D9Trace::RegisterSoftwareDevice(void *pInitializeFunction);

    //
    // Miembros
    //
     private:
        IDirect3D9 * m_pInterface;
    };

}

#endif //__CD3D9TRACE_H__
